<?php
/**********************************************************************************
 *
 * adiImage Fotogalerie
 *
 * v.0.7 - 2007-10-13
 * Copyright 2007 Peter Haunert
 *
 * http://www.netlane.de/adiImage/
 *
 ****************************************************************************
 *        based on: Weatimages 1.7.2, Copyright 2003-2007 Vladimir Nazarkin
 *                  http: *nazarkin.name/projects/weatimages/
 *                  weatimages@nazarkin.name
 ****************************************************************************
 *
 * This file is part of adiImage Fotogalerie.
 *
 * adiImage is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * $Id$
 *
/**********************************************************************************/







//begin html page

function html_begin($title, $start, $header, $comment) {

	global $ini, $langpack;

	if (empty($title) || '.' == $title) {
		$title = $langpack['albums'];
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php echo $title ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $ini['charset'] ?>"/>
<meta name="Generator" content="Weatimages"/>
<?php

	if ('' != $ini['external_css'] && is_readable($ini['adiPath'].$ini['external_css'])) {
		// print('<link href="' . ( ('/' != dirname($_SERVER['SCRIPT_NAME'])) ? dirname($_SERVER['SCRIPT_NAME']) : '' ) . '/' . $ini['external_css'] . '" rel="stylesheet" type="text/css">');
		print('<link href="' . $ini['adiServerPath'] . $ini['external_css'] . '" rel="stylesheet" type="text/css">');
	}
	else {

?>

	<style type="text/css">
	<!--
	body {
		font-family: "Trebuchet MS", Verdana, Helvetica, Arial, sans-serif;
		color: #333333;
		font-size: 11px;
		text-align: center;
		margin-top: 0px;
		padding-top: 0px;
		margin-bottom: 2px;
		margin-left: 0px;
		margin-right: 0px;
		padding: 0px;
		background-color: #FFFFFF;
	}
	a, a:link, a:visited {
		color: #002277;
		text-decoration: underline;
	}
	a:hover {
		color: #EE5500;
	}
	a:active {
		color: #FF0000;
	}
	.weatimages_thumbnail_cell {/* cell displayed in album view and containing image thumbnail, filename, description */
		font-family: Helvetica, Arial, sans-serif;
		padding: 4px 4px 8px 4px;
		border-style: solid;
		border-color: #DDDDDD;
		text-align: center;
		vertical-align: top;
	}
	.weatimages_thumb_border {/* border of thumbnail */
		padding: 0px;
		border-width: 1px;
		border-style: solid;
		border-color: #999999;
		margin: 6px 6px 2px 6px;
	}
	.weatimages_link_size {/* links to original/resized image displayed under thumbnail in album */
		font-size: 9px;
		text-decoration: underline;
		color: #333366;
		text-align: center;
	}
	.weatimages_filename {/* filename displayed under image thumbnail in album */
		font-size: 9px;
		color: #666666;
		font-weight: bold;
		text-align: center;
	}
	.weatimages_image_desc {/* description (from textfile or exif) displayed under image thumbnail in album */
		color: #555555;
		text-align: center;
	}
	.weatimages_pages_navigator {/* pager */
		font-size: 12px;
		color: #003366;
		text-align: center;
	}
	.weatimages_header {/* page title line - album/image name (or description) */
		font-size: 15px;
		color: #333333;
		margin-top: 4px;
		margin-bottom: 2px;
		margin-left: 20px;
		margin-right: 20px;
	}
	.weatimages_comment {/* string under page title - album/image description */
		font-size: 12px;
		color: #555555;
		margin-bottom: 3px;
		margin-left: 20px;
		margin-right: 20px;
	}
	.weatimages_thumb_album_name {/* album name shown on the right of album thumbnail */
		font-size: 14px;
		color: #333333;
	}
	.weatimages_thumb_album_desc {/* album decsription shown on the right of album thumbnail */
		font-size: 12px;
		color: #555555;
	}
	.weatimages_bigimage {/* style for big version of image */
		padding: 0px;
		border-width: 1px;
		border-style: solid;
		border-color: #444444;
		margin: 5px;
		text-align: center;
	}
	.weatimages_container_navig {/* links to next/previous images displayed at the page vith big version of image */
		font-size: 11px;
		text-decoration: underline;
	}
	.weatimages_toppest_navig {/* style for a div containing top navigational links - to parent albums and next/prev images */
		color: #555555;
		background-color: #FAFBFB;
		padding-left: 20px;
		padding-right: 20px;
		margin-bottom: 5px;
	}
	.weatimages_hotkey_tip {/* tips beside links to next/previous images */
		font-size: 11px;
		color: #BBBBBB;
	}
	-->
	</style>

<?php

	}//if ($ini['enable_external_css']) { ... } else {

?>
<script language="javascript" type="text/javascript">
	<!--
	var slideshow_onload = null; //should be implemented as a function later in this document if it must be called onload
	var slideshow = null; //should be implemented as a function later in this document when this function is needle

	function go_link(link_object) {
		location.href = link_object.href;
	}
	function ev(e) { //process window events
		if (!e) var e = window.event;
		var key = (e.keyCode)? e.keyCode : ((e.which)?e.which:0);
		link_id = false;
		link_obj = null;
		if ((35 == key) && (true == e.ctrlKey)) { //ctrl + end
			link_id = 'page_last';
		}
		else if ((36 == key) && (true == e.ctrlKey)) { //ctrl + home
			link_id = 'page_first';
		}
		else if ((37 == key) && (true == e.ctrlKey)) { //ctrl + arrow left
			link_id = 'page_previous';
		}
		else if ((38 == key) && (true == e.ctrlKey)) { //ctrl + arrow up
			link_id = 'page_up';
		}
		else if ((39 == key) && (true == e.ctrlKey)) { //ctrl + arrow right
			link_id = 'page_next';
		}
		else if ((40 == key) && (true == e.ctrlKey)) { //ctrl + arrow down
			if (slideshow) {
				slideshow();
			}
		}
		if (link_id) link_obj = document.getElementById(link_id);
		if (link_obj) go_link(link_obj);
	}
	document.onkeydown = ev;

	function onload_init() {
		if (slideshow_onload) {
			slideshow_onload();
		}
	}
	//-->
</script>
</head>
<body onload="onload_init();">
<?php

	if ($ini['enable_custom_container']) {
		@include('weatimages_top.inc.php');
	}
	print($start);
	if ($header && '.' != $header && $header != ".: ") {
		print('<div align="center" class="weatimages_header">' . $header . '</div>');
	}
	if ($comment) {
		print('<div align="center" class="weatimages_comment">' . $comment . '</div>');
	}

}//function html_begin(


/***********************************************************************************************************************/


function html_end() {

	global $ini, $langpack;
	global $login, $isLoggedIn;

//You should not to remove the following software signature
?>
<div align="right" class="tiny" style="margin:15px; margin-bottom: 20px">

<?php

	if ($ini['enable_admin'] && $login && !$isLoggedIn) {
		showLoginForm();
	} else if ($ini['enable_admin'] && $isLoggedIn) {
		showAdminMenu();
	} else if ($ini['enable_admin'] && !$isLoggedIn) {
		// show login-link
		echo '<a href="?login=1">login</a><br>';
	}

?>


	<?php echo $langpack['powered_by'] ?>
	<a href="http://www.netlane.de/adiImage/" target="_blank">adiImage</a><br>
	based on:
	<a href="http://nazarkin.name/projects/weatimages/" target="_blank">Weatimages 1.7.2</a></div>
<?php

	if ($ini['enable_custom_container']) {
		@include('weatimages_bottom.inc.php');
	}

?>
</body>
</html>
<?php

}//function html_end

/***********************************************************************************************************************/


function showLoginForm() {

?>
	<form method="POST" action="<?php getCurrentPath(); ?>">
		<input type="hidden" name="login" value="1" />
		<input type="text" name="admin" value="" class="frmbox" />
		<input type="password" name="pwd" value="" class="frmbox" />
		<input type="submit" name="submit" value=" login" class="btn" />
	</form>

<?php

}

/***********************************************************************************************************************/


function showAdminMenu() {

?>
		<br>
		<br>
	<div class="weatimages_thumb_album_desc" style="border-top: 1px solid #cccccc; border-right: 1px solid #cccccc; padding-right:20px; width: 75%">
		<br>

		<form method="POST" action="<?php echo getCurrentPath(); ?>">
			<input type="hidden" name="action" value="descs" />
			<input type="submit" name="submit" value="edit descriptions" class="btn" />
		</form>

		<br>

		<form method="POST" action="<?php echo getCurrentPath(); ?>" enctype="multipart/form-data">

		new image:
			<input type="hidden" name="action" value="add" />
			<input type="file" name="image" class="frmbox" /><br>
			<input type="submit" name="upload" value="upload" class="btn" />
		</form>

		<br>

		<form method="POST" action="<?php echo getCurrentPath(); ?>" enctype="multipart/form-data">

		new album:
			<input type="hidden" name="action" value="add" />
			<input type="text" name="newalbum" value="" class="frmbox" />
			<input type="submit" name="submit" value="create" class="btn" />
		</form>

		<br>

		<form method="POST" action="<?php echo getCurrentPath(); ?>">

			<input type="hidden" name="login" value="1" />
			<input type="hidden" name="admin" value="-" />
			<input type="submit" name="submit" value="log out" class="btn" />
		</form>
	</div>

<?php

}

/***********************************************************************************************************************/


/**
 * show pages-navigation-bar on thumbnails page if there are more then one page
 */
function show_pages_navigator($objects_count, $objects_on_page, $page_current, $page_query_string) {

	//$objects_count - total objects amount
	//$objects_on_page - amount of objects on a single page
	//$page_current - current page number
	//$page_query_string - string used as pagenumber variable name in http query

	global $ini, $langpack, $SERVER_PHP_SELF;

	if ($objects_count > $objects_on_page) {
		print('<div class="weatimages_pages_navigator"><span class="weatimages_thumb_album_name">' . $langpack['page'] . ':&nbsp;&nbsp;</span>');
		//print link to previous page if current page isn't first
		if (1 != $page_current) {
			print('<a href="'
				. url_compat( $SERVER_PHP_SELF . '?' . $page_query_string . '=' . ($page_current-1) )
				. '" style="font-size:15px; font-weight:bold;">&lsaquo;&nbsp;&nbsp;</a>');
		}
		for ($i = 1; $objects_count > ($i-1)*$objects_on_page; $i++) {
			if ($i != $page_current) {
				print('<a href="'
					. url_compat($SERVER_PHP_SELF . '?' . $page_query_string . '=' . $i)
					. '">&nbsp;' . $i . ' </a>');
			}
			else {
				print('<font style="font-size: 14px; color:#555555; background-color:#F2F2F2; text-decoration:underline;">&nbsp;' . $i . '&nbsp;</font>');
			}
		}
		//print link to next page if current page isn't last
		if ( $objects_count > ($page_current*$objects_on_page) ) {
			print('<a href="'
				. url_compat($SERVER_PHP_SELF . '?' . $page_query_string . '=' . ($page_current+1))
				. '" style="font-size:15px; font-weight:bold;">&nbsp;&nbsp;&rsaquo;</a>');
		}
		print('</div>');
	}
}//function show_pages_navigator(

/***********************************************************************************************************************/


/**
 * output cell with thumbnail and image info
 */
function show_thumbnail_cell($uri_original, $uri_resize, $uri_thumb, $filesize_kb, $imagesize, $resizesize, $is_resize_senseless, $filename, $desc) {
	global $ini, $langpack;
	global $isLoggedIn;

	$thumbsize = 0;
	if ($ini['enable_size_lookup']) {//get thumbnail width and height
		$thumbsize = calc_size_after_resize($imagesize, $ini['thumb_size']);
	}
	if ($ini['enable_size_lookup'] && $ini['default_size_resize'] && $is_resize_senseless) { $uri_original .= '&amp;preferredsize=resize'; }
	print('<td align="center" valign="center" class="weatimages_thumbnail_cell" width="' . ($ini['thumb_size'] + 14) . '"'
		. ' style="border-width: ' . ($ini['enable_cell_border'] ? '1' : '0') . 'px;">'
		. '<a name="' . $filename . '" href="'
		. (($ini['default_size_resize'] && !$is_resize_senseless) ? $uri_resize : $uri_original) . '"'
		. ($ini['enable_new_window']?' target="blank"':'') .'>'
		. '<img src="' . $uri_thumb . '"'
		. (($ini['enable_size_lookup'])?' width="' . $thumbsize[0] . '" height="' . $thumbsize[1] . '"':'')
		. ' class="weatimages_thumb_border" title="' . $langpack['thumbnail_hint'] . '" alt="' . $filename . '"/>'
		. '</a>'
		. ($ini['enable_filename_display'] ? '<div class="weatimages_filename">' . wordwrap(clean_filename($filename), 30, '<br/>', 1) . '</div>' : '')
		. ( ($ini['enable_resize'] || $ini['enable_size_lookup']) ?
			'<div class="weatimages_link_size">'
			. '<a href="' . $uri_original . '"'. ($ini['enable_new_window']?' target="blank"':'') .' >'
			. (($ini['enable_resize'] && !$is_resize_senseless) ? $langpack['original'] : '')
			. ($ini['enable_size_lookup']?' '.$imagesize[0].'x'.$imagesize[1].' ('.$filesize_kb.$langpack['kilobytes'].')':'')
			. '</a>'
			. ( (!$is_resize_senseless && $ini['enable_resize']) ?
				($ini['enable_size_lookup']?'<br/>':' | ')
				. '<a href="' . $uri_resize . '"'. ($ini['enable_new_window']?' target="blank"':'') .'>'
				. $langpack['resized']. ($ini['enable_size_lookup']?' '.$resizesize[0].'x'.$resizesize[1]:'')
				. '</a>' : ''
			)//( (!$is_resize_senseless && $ini['enable_resize']) ?
			. '</div>' : ''
		)//( ($ini['enable_resize'] || $ini['enable_size_lookup']) ?
		. (($ini['enable_description'] && $desc) ? '<div class="weatimages_image_desc">' . $desc . '</div>' : '')
		. ($isLoggedIn ? '<form action="'.getCurrentPath().'" method="post">'
								.'<input type="hidden" name="pic" value="'.$filename.'" />'
								.'<input type="hidden" name="action" value="rem" />'
								.'<input type="submit" value="delete" class="btn" /></form>' : "")
		. '</td>'
	);//print('<td
}//function show_thumbnail_cell(



//Prints link to album on expanded view
function print_expanded_album_link($album_path, $album_page, $album_picture) {
	//$album_path - relative path to album link to which is wanted
	//$album_page - page of the album
	//$album_picture - picture which should be focused when user clicks this link
	global $ini, $langpack;
	if ($ini['enable_new_window']) { //create link for closing this window
?>
<script language="javascript" type="text/javascript">
<!--
document.write('<a id="page_up" href="javascript:window.close();" class="weatimages_container_navig"><?php echo $langpack['close_window'] ?></a>');
//-->
</script><noscript><?php print('<a id="page_up" href="' . url_compat($_SERVER['SCRIPT_NAME'] . '/' . $album_path . '?page=' . $album_page . '#' . $album_picture) . '" class="weatimages_container_navig">' . $langpack['return_to_album'] . '</a>'); ?></noscript>
<?php
	}//if ($ini['enable_new_window'])
	elseif ('true' == $_GET['fromthumbnail']) { //create link for return to thumbnails page
?><script language="javascript" type="text/javascript">
<!--
if (history.length > 0) {
document.write('<a id="page_up" href="javascript:history.back();" class="weatimages_container_navig"><?php echo $langpack['return_to_album'] ?></a>');
}
else {
document.write('<?php print('<a id="page_up" href="' . url_compat($_SERVER['SCRIPT_NAME'] . '/' . $album_path . '?page=' . $album_page . '#' . $album_picture) . '" class="weatimages_container_navig">' . $langpack['return_to_album'] . '</a>'); ?>');
}
//-->
</script><noscript><?php print('<a id="page_up" href="' . url_compat($_SERVER['SCRIPT_NAME'] . '/' . $album_path . '?page=' . $album_page . '#' . $album_picture) . '" class="weatimages_container_navig">' . $langpack['return_to_album'] . '</a>'); ?></noscript><?php
	}
	else {
		print('<a id="page_up" href="' . url_compat($_SERVER['SCRIPT_NAME'] . '/' . $album_path . '?page=' . $album_page . '#' . $album_picture) . '" class="weatimages_container_navig">' . $langpack['return_to_album'] . '</a>');
	}
}//function print_expanded_album_link(



/**
 * Prints navigation bar for expanded view
 */
function print_expanded_navigation($album_path, &$pictures, $i) {

	//$album_path - relative path to album
	//&$pictures - referencr to array containing picture filenames
	//$i - index of current image in array

	global $ini, $langpack;



	//show links to first and last images, and to thumbnail page
	print('<div align="center" class="weatimages_toppest_navig">'
	     .'<table cellspacing="0" cellpadding="0"><tr>');

	//create link to first image in album, only if current image isn't first
	if ($ini['enable_slideshow']) {
		echo '<td align="right" width="200" style="padding-right:10px;">';
		if (0 != $i) {//if current image is not the first image, we'll create link to first
			print('<script language="javascript" type="text/javascript"><!--'."\r\n".'document.write(\'<span class="weatimages_hotkey_tip">(Ctrl Home)&nbsp;</span>\');'."\r\n".'//--></script>');
			print('<a id="page_first" href="' . get_expanded_navig_url($album_path.'/'.$pictures[0]) . '" class="weatimages_container_navig"><strong style="font-size:12px; line-height:11px;">&lsaquo;&lsaquo;&nbsp;</strong> ' . $langpack['first_image'] . '</a> ');
		}//if (0 != $i)

		echo '</td>';

		//create link to thumbnail page (exactly to page number on which located current image)
		echo '<td align="center">';

		$album_page = ceil(($i+1) / ($ini['cols']*$ini['rows'])); //number of album page which contains thumbnail of current image

		print_expanded_album_link($album_path, $album_page, $pictures[$i]);

		echo '</td>';

		//create link to last image in album, if current image isn't last
		echo '<td align="left" width="200" style="padding-left:10px;">';
		$i_last = count($pictures) - 1;
		if ($i < $i_last) {
			print(' <a id="page_last" href="' . get_expanded_navig_url($album_path.'/'.$pictures[$i_last]) . '" class="weatimages_container_navig">' . $langpack['last_image'] . ' <strong style="font-size:12px; line-height:11px;">&nbsp;&rsaquo;&rsaquo;</strong></a>');
			print('<script language="javascript" type="text/javascript"><!--'."\r\n".'document.write(\'<span class="weatimages_hotkey_tip">&nbsp;(Ctrl End)</span>\');'."\r\n".'//--></script>');
		}//if ($pictures[$i+1]) {
		echo '</td>';
		echo '</tr><tr>';
	}//if ($ini['enable_slideshow']) {

	//create link to previous image, if exists
	echo '<td align="right" width="200" style="padding-right:10px;">';

	if ($pictures[$i-1]) {//if previous image exists, we'll create link to it
		print('<script language="javascript" type="text/javascript"><!--'."\r\n".'document.write(\'<span class="weatimages_hotkey_tip">(Ctrl &larr;)&nbsp;</span>\');'."\r\n".'//--></script>');
		print('<a id="page_previous" href="' . get_expanded_navig_url($album_path.'/'.$pictures[$i-1]) . '" class="weatimages_container_navig"><strong style="font-size:12px; line-height:11px;">&lsaquo;&nbsp;</strong> ' . $langpack['previous_image'] . '</a> ');
	}//if ($pictures[$i-1]) {

	echo '</td>';

	//container for slideshow controller
	if ($ini['enable_slideshow']) {
		echo '<td id="slideshow_container" align="center">&nbsp;</td>';
	}
	else {//create link to thumbnail page
		echo '<td align="center">';
		$album_page = ceil(($i+1) / ($ini['cols']*$ini['rows'])); //number of album page which contains thumbnail of current image
		print_expanded_album_link($album_path, $album_page, $pictures[$i]);
		echo '</td>';
	}
	//create link to next image, if it exists
	echo '<td align="left" width="200" style="padding-left:10px;">';
	if ($pictures[$i+1]) {
		print(' <a id="page_next" href="' . get_expanded_navig_url($album_path.'/'.$pictures[$i+1]) . '" class="weatimages_container_navig">' . $langpack['next_image'] . ' <strong style="font-size:12px; line-height:11px;">&nbsp;&rsaquo;</strong></a>');
		print('<script language="javascript" type="text/javascript"><!--'."\r\n".'document.write(\'<span class="weatimages_hotkey_tip">&nbsp;(Ctrl &rarr;)</span>\');'."\r\n".'//--></script>');
	}//if ($pictures[$i+1]) {
	echo '</td>';
	print('</tr></table></div>');
}//function print_expanded_navigation(



//Output slideshow javascript code to the browser
function print_slideshow() {
	global $ini, $langpack;
	if (!$ini['enable_slideshow']) {
		return;
	}

  // else printout js-code for slideshow:
?>
	<script language="javascript" type="text/javascript">
	<!--
	var LANGPACK_SLIDESHOW_START = "<?php echo $langpack['slideshow_start'] ?>";
	var LANGPACK_SLIDESHOW_STOP = "<?php echo $langpack['slideshow_stop'] ?>";
	var SLIDESHOW_INTERVAL = 1000 * <?php echo $ini['slideshow_delay'] ?>;
	var strUrlMarker = 'slideshow=true';
	var iTimerId = 0;
	var bSlideshowRunning = ((location.href.length-strUrlMarker.length) == location.href.lastIndexOf(strUrlMarker)) ? true : false;
	var next_obj = null;
	var first_obj = null;

	function slideshow_init() {
		next_obj = document.getElementById('page_next');
		first_obj = document.getElementById('page_first');
		if (next_obj || first_obj) {
			document.getElementById('slideshow_container').innerHTML = '<a id="slideshow_control" onclick="javascript:slideshow();" style="cursor:pointer">' + ( (bSlideshowRunning && next_obj) ? LANGPACK_SLIDESHOW_STOP : LANGPACK_SLIDESHOW_START ) + '</a>';
		}
		if (bSlideshowRunning && !next_obj) {
			bSlideshowRunning = false;
		}
	}

	function slideshow_go() {
		location.href = ( (next_obj) ? next_obj.href : first_obj.href ) + '&amp;' + strUrlMarker;
	}
	function slideshow_start() {
		iTimerId = setTimeout('slideshow_go();', SLIDESHOW_INTERVAL);
		bSlideshowRunning = true;
		document.getElementById('slideshow_control').innerHTML = LANGPACK_SLIDESHOW_STOP;
	}
	function slideshow_stop() {
		clearTimeout(iTimerId);
		bSlideshowRunning = false;
		document.getElementById('slideshow_control').innerHTML = LANGPACK_SLIDESHOW_START;
	}
	function slideshow() {
		if (!bSlideshowRunning) slideshow_start();
		else slideshow_stop();
	}
	function slideshow_onload() {
		if (bSlideshowRunning && next_obj) {
			slideshow_start();
		}
	}

	slideshow_init();
	//-->
	</script>

<?php

}//function print_slideshow(



/**
 * Output html container with big image
 */
function page_big() {

	global $ini, $langpack, $REQUEST_PATH, $isLoggedIn;

	list($pictures, $others, $dirs, $descs) = load_directory(dirname($REQUEST_PATH), FALSE);
	$i = array_search(basename($REQUEST_PATH), $pictures);
	list(/* $filesize_kb_current */, $imagesize_current, $resizesize_current, $is_resize_senseless_current, $exif_comment_current) = get_image_sizes($REQUEST_PATH);
	if (!$descs[$pictures[$i]]) {
		$descs[$pictures[$i]] = $exif_comment_current;
	}

	//show page header depending on prefences
	if ($ini['enable_filename_display']) {
		html_begin(clean_filename($pictures[$i]), '', '', '');
	}
	else {
		html_begin(($descs[$pictures[$i]])?$descs[$pictures[$i]]:clean_filename($pictures[$i]), '', '', '');
	}

	//print navigational panel
	print_expanded_navigation(dirname($REQUEST_PATH), $pictures, $i);
	print_slideshow(); //all navigational links just created, now we can initialize slideshow

	//show title and description
	if ($ini['enable_filename_display']) {
		print('<div align="center" class="weatimages_header">' . clean_filename($pictures[$i]) . '</div>');
		print('<div align="center" class="weatimages_comment">' . $descs[$pictures[$i]] . '</div>');
	}
	else {
		print('<div align="center" class="weatimages_header">' . $descs[$pictures[$i]] . '</div>');
	}

	//show big image
	if (!$ini['enable_resize']) { $is_resize_senseless_current = TRUE; }//resize really senseless when resize completely disabled
	list($uri_original, $uri_resize, /* $uri_thumb */) = get_image_urls(dirname($REQUEST_PATH), basename($REQUEST_PATH), FALSE);
	list($uri_original_contained, $uri_resize_contained, /* $uri_thumb */) = get_image_urls(dirname($REQUEST_PATH), basename($REQUEST_PATH), TRUE);
	print('<div align="center">');
	if ('original' == $_GET['size']) {
		if (!$is_resize_senseless_current) { print('<a href="' . $uri_resize_contained . '">'); }
		print('<img src="' . $uri_original . '" class="weatimages_bigimage"' . ((!$is_resize_senseless_current)?' title="' . $langpack['switch_size_toresized'] . '"':'') . ' alt="' . $pictures[$i] . '" width="'.$imagesize_current[0].'" height="'.$imagesize_current[1].'"/>');
		if (!$is_resize_senseless_current) { print('</a>'); }
	}
	else {
		if (!$is_resize_senseless_current) { print('<a href="' . $uri_original_contained . '">'); }
		print('<img src="' . $uri_resize . '" class="weatimages_bigimage"' . ((!$is_resize_senseless_current)?' title="' . $langpack['switch_size_tofullsize'] . '"':'') . ' alt="' . $pictures[$i] . '" width="'.$resizesize_current[0].'" height="'.$resizesize_current[1].'"/>');
		if (!$is_resize_senseless_current) { print('</a>'); }
	}
	print('</div>');

	// admins get a delete-button
	if ($isLoggedIn) {
		print('<form action="' .getCurrentPath(). '" method="post"><input type="hidden" name="pic" value="' . basename($REQUEST_PATH) . '" />'
				.'<input type="hidden" name="action" value="rem" />'
				.'<input type="submit" value="delete" class="btn" /></form>');
	}

	if (!$is_resize_senseless_current) {
		print('<div class="tiny">' . $langpack['switch_size_bottomhelp'] . '</div>');
	}
	//Show last description
	if ($descs[$pictures[$i].'.']) {
		print('<div align="center" class="weatimages_comment">' . $descs[$pictures[$i].'.'] . '</div>');
	}
	html_end();
}//function page_big(



/**
 * display a text almost nicely and exit
 */
function fatal_error($title = 'Unknown error', $comment = '') {
	global $REQUEST_PATH;

	$info = '<br><br>' . $title . '<br><br><a href="'.getCurrentPath().'">continue</a>';
	html_begin($title, '', $info, $comment);
	html_end();
	exit();
}



	//show breadcrumbs-trace (navigational links to upper directories)

function breadcrumbs() {

	global $REQUEST_PATH, $ini, $langpack;

	if ($ini['enable_albums_listing'] && '.' != $REQUEST_PATH) {
		$pathSepp = "&nbsp;>&nbsp;";
		$link = $pathSepp . clean_filename(basename($REQUEST_PATH));
		// step up through parent-dirs
		for ($path = dirname($REQUEST_PATH); '.' != $path; $path = dirname($path)) {
			$link = $pathSepp .'<a href="' . url_compat($_SERVER['SCRIPT_NAME'] . '/' . $path) . '">'
			      . clean_filename(basename($path)) . '</a> '
			      . $link;
		}
		$link = ' <a href="' . $_SERVER['SCRIPT_NAME'] . '">' . $langpack['albums'] . '</a> ' . $link;
		$link = '<div align="center" class="weatimages_toppest_navig">' . $link . '</div>';
	}//if ('.' != $REQUEST_PATH)

	return $link;
}





/**
 * show page with thumbnails if a correct path for an album was requested
 */
function editDescsForm() {

	global $ini, $langpack, $isLoggedIn;
	global $REQUEST_PATH, $SERVER_PHP_SELF;

	if (!$isLoggedIn) {

		return;
	}

	$pfx = $ini['descs_prefix'];

	//do some simple checks
	if (!is_dir($REQUEST_PATH)) {
		fatal_error('Album not found', $ini['enable_albums_listing'] ? 'Try to start browsing from the <a href="' . $_SERVER['SCRIPT_NAME'] . '">root album</a>.' : 'Check the album name and then try again.');
	}

	//read directory contents and descriptions
	list($pictures, $others, $dirs, $descs) = load_directory($REQUEST_PATH, FALSE);
	if ('.' != $REQUEST_PATH && !$descs['.'] && !$descs['..']) {//try to get album description from descs-file in parental directory
		$parent_descs = load_descriptions(dirname($REQUEST_PATH));
		$descs['.'] = $parent_descs[basename($REQUEST_PATH)];
	}

	$title = "edit descriptions";
	$info = "";
	$comment = "";
	html_begin($title, '', $info, $comment);

	echo '<form action"'.getCurrentPath().'"><table>';
	echo '<tr><td colspan="2"> &nbsp; </td></tr>';
	echo '<tr><td colspan="2">THIS ALBUM</td></tr>';
	echo '<tr><td>Headline of current album:</td><td><input type="text" name="'.$pfx.'" value="'.$descs['.'].'" size="100%" /></td></tr>';
	echo '<tr><td>SubHeading:</td><td><input type="text" name="'.$pfx.'" value="'.$descs['..'].'" size="100%" /></td></tr>';

	if (count($dirs)) {
		echo '<tr><td colspan="2"> &nbsp; </td></tr>';
		echo '<tr><td colspan="2">SUB-ALBUMS</td></tr>';
		foreach ($dirs as $filename) {
			$fileClean = str_replace(".", "", $filename);
			echo "<tr><td>".$filename .'</td><td><input type="text" name="'.$pfx
					.$fileClean.'" value="'.$descs[$filename].'" size="100%" /></td></tr>';
		}
	}

	if (count($pictures)) {
		echo '<tr><td colspan="2"> &nbsp; </td></tr>';
		echo '<tr><td colspan="2">IMAGES</td></tr>';
		foreach ($pictures as $filename) {
			$fileClean = str_replace(".", "", $filename);
			echo "<tr><td>".$filename .'</td><td><input type="text" name="'.$pfx
					.$fileClean.'" value="'.$descs[$filename].'" size="100%" /></td></tr>';
		}
	}

	if (count($others)) {
		echo '<tr><td colspan="2"> &nbsp; </td></tr>';
		echo '<tr><td colspan="2">OTHER FILES</td></tr>';
		foreach ($others as $filename)
			echo "<tr><td>".$filename .'</td><td><input type="text" name="'.$pfx
					.$filename.'" value="'.$descs[$filename].'" size="100%" /></td></tr>';
	}

	echo '<tr><td colspan="2"><input type="submit" name="submit" value="save"> &nbsp;  &nbsp; <input type="reset" name="cancel" value="cancel"></td></tr>';
	echo '<input type="hidden" name="action" value="savedescs" />';
	echo '</table></form>';

	html_end();

}



/**
 * show page with thumbnails if a correct path for an album was requested
 */
function displayAlbum() {

	global $ini, $langpack;
	global $REQUEST_PATH, $SERVER_PHP_SELF;

	//do some simple checks
	if (!is_dir($REQUEST_PATH)) {
		fatal_error('Album not found', $ini['enable_albums_listing'] ? 'Try to start browsing from the <a href="' . $_SERVER['SCRIPT_NAME'] . '">root album</a>.' : 'Check the album name and then try again.');
	}

	//read directory contents and descriptions
	list($pictures, $others, $dirs, $descs) = load_directory($REQUEST_PATH, FALSE);
	if ('.' != $REQUEST_PATH && !$descs['.'] && !$descs['..']) {//try to get album description from descs-file in parental directory
		$parent_descs = load_descriptions(dirname($REQUEST_PATH));
		$descs['.'] = $parent_descs[basename($REQUEST_PATH)];
	}

	$link = breadcrumbs();

	$title = $descs['.'] ? $descs['.'] : basename($REQUEST_PATH);
	$desc = ($descs['.'] || $ini['enable_albums_listing']) ? $descs['.'] : "";
	$header = ( basename($REQUEST_PATH) == "." ? "" : basename($REQUEST_PATH).": " );
	$header .= $desc;
	$subHeader = $descs['..'];

	html_begin($title, $link, $header, $subHeader);

	showAlbumsList($dirs, $descs);

	showThumnails($pictures, $descs);

	// display zip -link if enabled
	if ($ini['enable_album_zip'] && (count($pictures) > 0 || count($others) > 0)) {
		print ('<div align="center" style="width:100%;"><a href="'
			. url_compat($SERVER_PHP_SELF . '?action=zip')
			. '">' . $langpack['album_zip'] . '</a></div>'
		);
	}

	showOtherFilesList($others, $descs);

	html_end();

}//displayAlbum


/***********************************************************************************************************************/


function showAlbumsList($dirs, $descs)
{
	global $ini, $langpack, $isLoggedIn;
	global $SERVER_PHP_SELF, $REQUEST_PATH;

	$dirs_count = count($dirs);

	if (!$ini['enable_albums_listing'] || $dirs_count == 0) {

		return;
	}

	 //show nested albums
	if ($_GET['page'] < 2 && $_GET['addspage'] < 2) {//show other items only if it is first thumbnails page
		$albumspage = ($_GET['albumspage'] > 0) ? $_GET['albumspage'] : 1;
		show_pages_navigator($dirs_count, $ini['albums'], $albumspage, 'albumspage');
		$bound_low = $ini['albums'] * ($albumspage - 1); //lowest index of $pictures[] which should be shown on current page
		$bound_high = ($ini['albums'] * $albumspage) - 1; //highest index of $pictures[] which should be shown on current page

		print('<table border="0" cellspacing="0" cellpadding="0" align="center" width="100%" style="margin-top:5px; margin-bottom:5px;">');
		print('<tr><td colspan="' . $ini['cols'] . '" align="center" valign="top">'
			. '<table border="0" cellspacing="0" cellpadding="0" align="center" width="'. $ini['cols']*$ini['thumb_size'] .'">'
			. '<tr><td align="left" class="album_header">' . $langpack['albums'] .'<a name="weatimagesdirsblock" style="visibility:hidden;">&nbsp;</a></td></tr>'
			. '<tr><td align="center" valign="top" style="padding-left:5px;'
			. ($ini['enable_albums_edging'] ? ' border-color:#AAAAAA; border-top-width:1px; border-top-style:dashed;' : '') . '">'
		);//print('

		print('<div align="left" class="tiny">' . $langpack['albums_hint'] . '</div>');
		print('<table border="0" cellspacing="0" cellpadding="0" align="center" style="font-size:13px;'
			. ((1 == $ini['enable_albums_edging']) ? ' border-color:#AAAAAA; border-left-width:1px; border-left-style:dashed;' : '')
			. '">');

		for ($i = 0; $i < $dirs_count; $i++) {
			if ($i < $bound_low) { continue; } //we still don't reached file which must be first on current page
			if ($i > $bound_high) { break; } //last file on current page was shown on previous iteration
			$uri_target = url_compat($SERVER_PHP_SELF . $dirs[$i]);

			if (0 == $i%$ini['albums_cols']) { print('<tr>'); }

			if ($ini['enable_albums_thumbs']) {
			     $nested_uri_thumb = get_album_thumb('./'.$REQUEST_PATH.'/'.$dirs[$i]);
			     if (!$nested_uri_thumb[0]) {
				     $nested_uri_thumb[0] = $SERVER_PHP_SELF . '?action=noimage';
				     $nested_uri_thumb[1][0] = $ini['thumb_size'];
				     $nested_uri_thumb[1][1] = ceil(0.75*$ini['thumb_size']);
			     }
			     print('<td align="right" valign="top" style="padding-left:10px; padding-right:0px; padding-top:10px;">'
				     . '<a href="'.$uri_target.'"><img src="' . $nested_uri_thumb[0]
				     . '" style="border-color:#CCCCCC; border-width:1px; border-style:solid;"'
				     . 'width="'.$nested_uri_thumb[1][0].'" height="'.$nested_uri_thumb[1][1].'" alt="'.$dirs[$i].'"/></a>'
				     . '</td><td align="left" valign="top" style="padding-left:10px; padding-right:30px; padding-top:20px;">'
				     . '<span class="weatimages_thumb_album_name">'.clean_filename($dirs[$i]).'</span><br/><span class="weatimages_thumb_album_desc">'.$descs[$dirs[$i]].'</span>'
						. ($isLoggedIn ? '<form action="'.getCurrentPath().'" method="post">'
							.'<input type="hidden" name="pic" value="'.$dirs[$i].'" />'
							.'<input type="hidden" name="action" value="rem" />'
							.'<input type="submit" value="delete" class="btn" /></form>' : "")
				     . '</td>'
				     );//print(
			} //if ($ini['enable_albums_thumbs']) {
			else {
			print('<td align="left" style="padding-left:5px; padding-top:2px; padding-right:10px;">'
				. '<table border="0" cellspacing="0" cellpadding="0"><tr>'
				. '<td align="right" valign="top"><strong>&raquo;</strong>&nbsp;<a href="' . $uri_target . '">' . clean_filename($dirs[$i]) . '</a><br>'
				. ($isLoggedIn ? '<form action="'.dirname(getCurrentPath()).'" method="post">'
					.'<input type="hidden" name="pic" value="'.basename(getCurrentPath()).'" />'
					.'<input type="hidden" name="action" value="rem" />'
					.'<input type="submit" value="delete" class="btn" /></form>' : "")
				.'</td>'
				. ( $descs[$dirs[$i]] ? '<td align="left" valign="top">&nbsp;<strong>:</strong>&nbsp;</td><td align="left" valign="top">'
				. $descs[$dirs[$i]]
				. '</td>' : '')
				. '</tr></table>'
				. '</td>'
			);//print(
			} //if (!$ini['enable_albums_thumbs']) { ELSE

			if ((0 == ($i+1)%$ini['albums_cols']) || ($i == $dirs_count-1)) { print('</tr>'); }
		}//for ($i = 0; $i < $others_count; $i++) {

		print('</table>'
			. '</td></tr>'

			. '<tr><td align="center" valign="top" style="padding-left:5px;'
			. ($ini['enable_albums_edging'] ? ' border-color:#AAAAAA; border-bottom-width:1px; border-bottom-style:dashed;' : '') . '">&nbsp; '
			. '</td></tr></table>'
			. '</td></tr>'
		);//print(

		print('</table>');

		show_pages_navigator($dirs_count, $ini['albums'], $albumspage, 'albumspage');
		print('<br/>');

	}//if ($_GET['page'] < 2)
	else {//it is not first thumbnails page, so we only mention about other items existence
		print('<table border="0" cellspacing="0" cellpadding="0" align="center" width="100%" style="margin-top:5px; margin-bottom:5px;">');
		print('<tr><td colspan="' . $ini['cols'] . '" align="center" valign="top" style="color:#777777;">'
			. '<a href="' . url_compat($SERVER_PHP_SELF . '?' . (($_GET['page'] > 1)?'page':'addspage') . '=1#weatimagesdirsblock') . '">' . $langpack['nested_albums_available'] . '</a>'
			. '</td></tr>'
		);//print(
		print('</table>');
	}//if ($_GET['page'] < 2) else

} // showAlbumsList

/***********************************************************************************************************************/


/**
 * Display thumnails of all images in current album
 */
function showThumnails($pictures, $descs) {

	global $ini, $langpack;
	global $REQUEST_PATH, $SERVER_PHP_SELF;

	$pictures_count = count($pictures);

	if ($pictures_count == 0) {

		return; // nothing to do
	}

	//show thumbnails

	$page = ($_GET['page'] > 0) ? $_GET['page'] : 1;
	$images_on_page = $ini['cols']*$ini['rows'];
	show_pages_navigator($pictures_count, $images_on_page, $page, 'page');

	$bound_low = $images_on_page * ($page - 1); //lowest index of $pictures[] which should be shown on current page
	$bound_high = ($images_on_page * $page) - 1; //highest index of $pictures[] which should be shown on current page
	$new_row_indicator = 0; //counter for decision when new row must be started

	print('<table align="center" cellspacing="10" border="0">');
	for ($i = 0; $i < $pictures_count; $i++) {
		if ($i < $bound_low) { continue; } //we still don't reached file which must be first on current page
		if ($i > $bound_high) { break; } //last file on current page was shown on previous iteration

		//get image sizes if size indication enabled
		if ($ini['enable_size_lookup']) {
			list($filesize_kb, $imagesize, $resizesize, $is_resize_senseless, $exif_comment) = get_image_sizes($REQUEST_PATH . '/' . $pictures[$i]);
		}//if ($ini['enable_size_lookup']) {

		if (!$descs[$pictures[$i]] && $exif_comment) {
			$descs[$pictures[$i]] = $exif_comment;
		}

		list($uri_original, $uri_resize, $uri_thumb) = get_image_urls($REQUEST_PATH, $pictures[$i], $ini['enable_html_container']);
		if ($ini['enable_html_container']) {//tell html container that it can return to thumbnails page simply using history.back() javascript call
			$uri_original .= '&amp;fromthumbnail=true';
			$uri_resize .= '&amp;fromthumbnail=true';
		}

		if (0 == $new_row_indicator++) {//we need to begin new table row
			print('<tr>');
		}

		show_thumbnail_cell($uri_original, $uri_resize, $uri_thumb, $filesize_kb, $imagesize, $resizesize, $is_resize_senseless, $pictures[$i], $descs[$pictures[$i]]);

		if ($new_row_indicator == $ini['cols'] || $i == $pictures_count - 1) { //we need to close row if number of columns reached or it was last image
			print('</tr>');
			$new_row_indicator = 0;
		}
	}//for ($i = 0; $i < $pictures_count; $i++) {

	print('</table>');

	show_pages_navigator($pictures_count, $images_on_page, $page, 'page');

}

/***********************************************************************************************************************/


function	showOtherFilesList($others, $descs) {

	global $ini, $langpack, $isLoggedIn;
	global $SERVER_PHP_SELF, $REQUEST_PATH;

	$others_count = count($others);

	if (!$ini['enable_additional_listing'] || $others_count == 0) {

		return;
	}

	//show links to non-thumbnailable items
	print('<table border="0" cellspacing="0" cellpadding="0" align="center" width="100%" style="margin-top:5px; margin-bottom:5px;">');
	if ($_GET['page'] < 2 && $_GET['albumspage'] < 2) {//show other items only if it is first thumbnails page
		$addspage = ($_GET['addspage'] > 0) ? $_GET['addspage'] : 1;
		$bound_low = $ini['additionals'] * ($addspage - 1); //lowest index of $pictures[] which should be shown on current page
		$bound_high = ($ini['additionals'] * $addspage) - 1; //highest index of $pictures[] which should be shown on current page
		print('<tr><td colspan="' . $ini['cols'] . '" align="center" valign="top">'
			. '<table border="0" cellspacing="0" cellpadding="0" align="center" width="'. $ini['cols']*$ini['thumb_size'] .'">'
			. '<tr><td align="left" style="font-size:12px; padding-left:5px;">' . $langpack['additional_items'] . '<a name="weatimagesothersblock" style="visibility:hidden;">&nbsp;</a></td></tr>'
			. '<tr><td align="center" valign="top" style="padding-left:5px;'
			. ($ini['enable_albums_edging'] ? ' border-color:#AAAAAA; border-top-width:1px; border-top-style:dashed;' : '') . '">'
		);//print('
		print('<table border="0" cellspacing="0" cellpadding="0" align="center" style="'
			. ((1 == $ini['enable_albums_edging']) ? ' border-color:#AAAAAA; border-left-width:1px; border-left-style:dashed;' : '')
			. '">');
		for ($i = 0; $i < $others_count; $i++) {
			if ($i < $bound_low) { continue; } //we still don't reached file which must be first on current page
			if ($i > $bound_high) { break; } //last file on current page was shown on previous iteration
			list($uri_original, /* $uri_resize */, /* $uri_thumb */) = get_image_urls($REQUEST_PATH, $others[$i], FALSE);
			$filesize_kb = ceil(filesize($REQUEST_PATH . '/' . $others[$i]) / 1024);
			print('<tr><td align="left" style="padding-left:5px;">'
				. '<table border="0" cellspacing="0" cellpadding="0"><tr>'
				. '<td align="right" valign="top"><strong>&raquo;</strong>&nbsp;<a href="' . $uri_original . '">' . $others[$i] . '&nbsp;(' . $filesize_kb . $langpack['kilobytes'] . ')' . '</a></td>'
				. ( $descs[$others[$i]] ? '<td align="left" valign="top">&nbsp;<strong>:</strong>&nbsp;</td><td align="left" valign="top">'
				. $descs[$others[$i]] . '</td>' : '')
				. '</tr></table>'
				. '</td></tr>'
			);//print(
		}//for ($i = 0; $i < $others_count; $i++) {
		print('</table>'
			. '</td></tr></table>'
			. '</td></tr>'
		);//print(
	}//if ($_GET['page'] < 2 && $_GET['albumspage'] < 2) {
	else {//it is not first thumbnails page, so we only mention about other items existence
		print('<tr><td colspan="' . $ini['cols'] . '" align="center" valign="top" style="color:#777777;">'
			. '<a href="' . url_compat($SERVER_PHP_SELF . '?' . (($_GET['page'] > 1)?'page':'albumspage') . '=1#weatimagesothersblock') . '">' . $langpack['additional_items_available'] . '</a>'
			. '</td></tr>'
		);//print(
	}//if (2 > $_GET['page']) else
	print('</table>');
	if ($_GET['page'] < 2 && $_GET['albumspage'] < 2) { show_pages_navigator($others_count, $ini['additionals'], $addspage, 'addspage'); }

}

/***********************************************************************************************************************/


?>
